/*
 * nocando.c - Denial shell with user notification and syslog logging.
 * @(#)nocando.c v1.4 31 AUG 2000 Rob Thomas robt@cymru.com
 * 
 * See the README file for all the details.  Type "make help" for more
 * assistance.
 * 
 * Permission is granted to utilize and distribute this tool as long as this
 * header is included and un-modified.
 *
 * 1.4 - Fixed indirection error as per Wietse Venema wietse@porcupine.org.
 *       Thanks, Wietse! 
 */

#ifndef lint
static char sccsid[] = "@(#)nocando.c v1.4 31 AUG 2000 Rob Thomas robt@cymru.com";
#endif

#include <stdio.h>
#include <syslog.h>
#include <stdlib.h>
#include <sys/utsname.h>
#include <pwd.h>

#ifndef SYSLOG_FAC
#define SYSLOG_FAC LOG_LOCAL3
#endif

int
main (argc, argv)
	int	argc;
	char	*argv[];
{
	struct	utsname	hostie;
	char	*myfname;
	char	*mylname;
	char	*msg1 = "You are not authorized to connect to ";
	char	*msg2 = "Please contact System Administration.  Thank you.";

	if (1 == VERBOSE) {
		myfname = getpwuid(getuid())->pw_gecos;
	} else {
		myfname = getpwuid(getuid())->pw_name;
	}
	mylname = getpwuid(getuid())->pw_name;
	uname(&hostie);

	openlog("nocando", LOG_PID, SYSLOG_FAC);

	fprintf(stderr, "\nHello %s,\n%s%s.\n%s\n\n", myfname, msg1,
		hostie.nodename, msg2);

	syslog (LOG_INFO, "login attempt by %s", mylname);

	closelog();

	exit(-1);
}
